#include "stdafx.h"
#include "CShrapnel.h"
#include "vector.h"
#include "ship.h"
extern randInt(int min, int max);

CShrapnel::CShrapnel()
{
	active = true;
	Pos.ex = 0;
	Pos.ey = 0;
	Dir.ex = 0;
	Dir.ey = 0;
	Pt.ex = 0;
	Pt.ey = 0;
}

void CShrapnel::spawn(ship &sh)
{
	active = true;
	for(int i=0; i<5; i++)
	{
		sb[i].active = true;
		sb[i].Pos.ex = sh.Pos.ex;
		sb[i].Pos.ey = sh.Pos.ey;
		sb[i].Dir.ex = randInt(1,3) - 1;
		sb[i].Dir.ey = randInt(1,3) - 1;
		sb[i].Pt.ex = sh.Pt.ex - randInt(1,10) - 5;
		sb[i].Pt.ey = sh.Pt.ey - randInt(1,10) - 5;
	}
	int rand;
	for(i=0; i<5; i++)
	{
		rand = randInt(50, 1000);
		sb[i].Pt.rotate(rand);
		sb[i].Dir.rotate(rand);
		sb[i].ttl = randInt(5,25);
	}
	ttl = 25;
}

void CShrapnel::onTick(CRect &rc)
{
	if(active)
	{
		for(int i=0; i<5; i++)
		{
			if(sb[i].active)
			{
				sb[i].Pos += sb[i].Dir;
				sb[i].Pos %= rc.Size();
				sb[i].ttl--;
				if(!sb[i].ttl)
					sb[i].active = false;
			}
		}
	}
	ttl--;
	if(!ttl)
		active = false;
}

void CShrapnel::Paint(CDC &rdc)
{
	if(active)
	{
		for(int i=0; i<5; i++)
		{
			if(sb[i].active)
			{
				rdc.SetPixel(sb[i].Pos, RGB(150,100,0));
				rdc.SetPixel(sb[i].Pos.ex+1, sb[i].Pos.ey+1, RGB(150,100,0));
				rdc.SetPixel(sb[i].Pos.ex+1, sb[i].Pos.ey-1, RGB(150,100,0));
				rdc.SetPixel(sb[i].Pos.ex-1, sb[i].Pos.ey-1, RGB(150,100,0));
				rdc.SetPixel(sb[i].Pos.ex-1, sb[i].Pos.ey+1, RGB(150,100,0));
			}
		}
	}
}
