#ifndef VeCtOr_H
#define VeCtOr_H
#include <math.h>

struct VECTOR
{
/*************************************************************/
public:
  double length() {  return sqrt( pow((ex), 2) + pow((ey), 2)); }
  double slope() {  return (ey) / (ex);  }
  double angle();
  double rangle() { return 1.0/(ex/length());}
  double rtod(double radians) { return (radians / 3.141592653) * 180; }
  double dtor(double degrees) { return (degrees / 180) * 3.141592653; }
  void setLength(double desiredLen);
//  void translate(double xdist, double ydist) {bx += xdist; ex += xdist; by += ydist; ey+= ydist;}
//  void flipX() { bx *= -1; ex *= -1;}  // flip over X-axis
//  void flipY() { by *= -1; ey  *= -1;} // flip over the Y-axis;
  void rotate(double degrees);
/*************************************************************/
 const VECTOR& operator = (const VECTOR &v1);
 const VECTOR& operator += (const VECTOR &v1);
 const VECTOR& operator -= (const VECTOR &v1);
 const VECTOR& operator *= (double d);
 const VECTOR& operator /= (double d);
 const VECTOR& operator %= (CSize size);
const VECTOR& operator %= (CRect r);

 VECTOR operator + (const VECTOR &v1);
 VECTOR operator - (const VECTOR &v1);
 VECTOR operator * (double d);
 VECTOR operator / (double d);
 VECTOR operator % (CSize size);
 VECTOR operator % (CRect r);

 operator CPoint() const;
 /*************************************************************/
  VECTOR();
  VECTOR(double x2, double y2);
  VECTOR(const VECTOR& v1);
  //  double bx, by;     //X & Y coords of beginning point
  double ex, ey;     //X & Y coords of end point
};
/*************************************************************/

#endif