#ifndef SHIP_DOT_H
#define SHIP_DOT_H
#include "stdafx.h"
#include "vector.h"
#include <math.h>
#include "bullet.h"
#include "CFlyingObject.h"
#include "CWeapon.h"

class CWeapon;

class ship : public CFlyingObject
{	
public:

	bool hit;	
	bool ai;
	int tabooCount;
	int hp;
	int invCount;
	int shipID;
	int score;
	int deaths;
	int numBulls;
	int coolDown;
	CPen myPen;
	CWeapon* pw;
	bullet b[10];			//The user has a max of 10 bullets
	int target;
	COLORREF myColor;

	ship();
	void accelerate(int direction);
	void turnLeft();
	void turnRight();
	void Paint(CDC &rdc);
	void tick(CRect &rc);
	void reset(int bullID);
	void aitarget(CFlyingObject &target);
	int aiPickTarget();
	int giveFreeBulletID();
	void spawn(double sposx, double sposy, double sdirx, 
			   double sdiry, double sptx, double spty);
	void CreateMyPen(COLORREF color);
};
#endif
